<template>
    <v-container>
        <v-card :loading="loading">
            <v-card-title style="color: #0ABBEF">
                <span class="display-1">{{ $t("Task.LNG_TASK_TASKS") }}</span>
                <v-spacer/>
            </v-card-title>
            <v-divider/>
            <v-card-text>
                <v-timeline v-if="tasks.length > 0">
                    <v-timeline-item v-for="task in tasks" :key="task.id"
                                     fill-dot
                                     small
                                     color="#0ABBEF"
                                     :icon="task.fieldIcon">
                        <span slot="opposite" class="subtitle-1">{{ displayDate(task.ending) }}</span>
                        <v-card class="elevation-2" shaped>
                            <v-card-title class="blue-grey white--text text-capitalize"
                                          style="padding: 6px 16px">
                                {{ task.title }}
                                <v-spacer/>
                                <task-edit v-if="isCurrentUserAdmin" :task="task" @updated="updateTasks"/>
                                <task-delete v-if="isCurrentUserAdmin" :task-id="task.id" @deleted="updateTasks"/>
                            </v-card-title>
                            <v-card-subtitle class="blue-grey white--text text-capitalize"
                                             style="padding: 6px 16px">
                                {{ task.fieldName }}
                            </v-card-subtitle>
                            <v-card-text style="padding-top: 6px">
                                {{ task.description }}
                            </v-card-text>
                            <v-card-actions v-if="task.contains_work" style="padding: 8px; justify-content: center">
                                <work-actions v-if="task.id" :task-id="task.id" style="width: 100%"/>
                            </v-card-actions>
                        </v-card>
                    </v-timeline-item>
                </v-timeline>
            </v-card-text>
        </v-card>
    </v-container>
</template>

<script>
import Services from "@/services/api";
import dayjs from 'dayjs';
import localizedFormat from 'dayjs/plugin/localizedFormat';
import 'dayjs/locale/fr';
import { mapGetters } from "vuex";
import TaskEdit from "@/components/TaskEdit.component";
import TaskDelete from "@/components/TaskDelete.component";
import WorkActions from "@/components/WorkActions.component";

export default {
    name: 'MyTasks',
    components: { WorkActions, TaskDelete, TaskEdit },
    data() {
        return {
            tasks: [],
            loading: true,
        }
    },
    computed: {
        ...mapGetters(['user', 'lessons']),
        isCurrentUserAdmin() {
            return this.user && (this.user.type === 'TEACHER' || this.user.type === 'ADMIN');
        },
    },
    methods: {
        displayDate: function (date) {
            let tmp = dayjs(date);
            return tmp.isValid() ? tmp.format("LLLL") : this.$t("Task.LNG_TASK_NO_DATE");
        },
        async getInfos(idLesson) {
            let lesson = await Services.Lesson.getLesson(idLesson);
            let field = null;

            if (lesson) {
                let fields = await Services.Fields.getFields();
                field = fields.find(f => f.id === lesson.id)
            }
            return {
                fieldId: field?.id || null,
                fieldName: field?.field_name || "",
                fieldIcon: field?.icon || "",
            };
        },
        async updateTasks() {
            let tmp = await Services.Task.getTasks();
            for (let task of tmp) {
                Object.assign(task, await this.getInfos(task.id_lesson));
            }
            this.tasks = tmp;
        }
    },
    async mounted() {
        dayjs.extend(localizedFormat);
        dayjs.locale(this.$i18n.locale);
        await this.updateTasks();
        this.loading = false;
    },
}
</script>
